import CreatSystem from '../lib/main';
import asyncRouterMap from '../router/asyncRoutes';

window.manageShell = { default: CreatSystem };
window.allAasyncRouterMap = [...asyncRouterMap];

let constantRouter = [
  {
    path: '/asd',
    name: 'asd',
    component: {
      template: '<div>asdasdasd</div>',
    },
  },
];
const routeFilter = (routes, allRoute) => {
  if (allRoute && allRoute.length) {
    let addRoute = manageShell.default.utils.route.formatRouteLink(allRoute);
    for (let index = 0; index < addRoute.length; index++) {
      const element = addRoute[index];
      if (element.children) {
        routes = routes.concat(element.children);
      } else if (
        element.menuCode === process.env.VUE_APP_REGISTER_DASHBOARD_CODE
      ) {
        routes.unshift(element);
      }
    }
  }
  return {
    allRoute,
    routes,
  };
};
const script = document.createElement('script');
script.text = `
  var routeNameList = [
    'customerManage',
    'baseManage',
    'systemManage',
    'operateManage',
    'statisticsManage',
    'deviceManage',
    'smaproManage',
  ];
  Promise.all(routeNameList.map(name => {
    var node = document.createElement("link");
    node.rel = "stylesheet";
    node.type = "text/css";
    node.href = '${
      process.env.VUE_APP_SUBSYSTEM
    }/' + name + '/lib/' + name + '.css?t=${new Date().getTime()}';
    document.getElementsByTagName("head")[0].appendChild(node);
    return System.import('${
      process.env.VUE_APP_SUBSYSTEM
    }/' + name + '/lib/' + name + '.umd.min.js?t=${new Date().getTime()}')
  }))
  .then(res => {
    for (let index = 0; index < res.length; index++) {
      const element = res[index];
      allAasyncRouterMap = allAasyncRouterMap.concat(element.default.default);
    }
    manageShell.default.createSystem({
      basePath: '${process.env.VUE_APP_BASE_URL}',
      routers: allAasyncRouterMap,
      constantRouter: ${JSON.stringify(constantRouter)},
      whiteList: '/asd',
      routeFilter: ${routeFilter.toString()},
    })
  })
  `;
document.body.appendChild(script);
